diff -urN punbb-1.3.4/misc.php punbb-1.3.6/misc.php
--- punbb-1.3.4/misc.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/misc.php	2011-03-15 15:15:48.808748000 +0000
@@ -154,6 +154,7 @@
 		message($lang_common['No permission']);
 
 	$recipient_id = intval($_GET['email']);
+	
 	if ($recipient_id < 2)
 		message($lang_common['Bad request']);
 
@@ -170,7 +171,9 @@
 	);
 
 	($hook = get_hook('mi_email_qr_get_form_email_data')) ? eval($hook) : null;
+
 	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+	
 	if (!$forum_db->num_rows($result))
 		message($lang_common['Bad request']);
 
@@ -179,6 +182,8 @@
 	if ($email_setting == 2 && !$forum_user['is_admmod'])
 		message($lang_misc['Form e-mail disabled']);
 
+	if ($recipient_email == '')
+		message($lang_common['Bad request']);
 
 	if (isset($_POST['form_sent']))
 	{
@@ -367,6 +372,9 @@
 	{
 		($hook = get_hook('mi_report_form_submitted')) ? eval($hook) : null;
 
+		// Start with a clean slate
+		$errors = array();
+
 		// Flood protection
 		if ($forum_user['last_email_sent'] != '' && (time() - $forum_user['last_email_sent']) < $forum_user['g_email_flood'] && (time() - $forum_user['last_email_sent']) >= 0)
 			message(sprintf($lang_misc['Report flood'], $forum_user['g_email_flood']));
@@ -376,72 +384,79 @@
 		if ($reason == '')
 			message($lang_misc['No reason']);
 
-		// Get some info about the topic we're reporting
-		$query = array(
-			'SELECT'	=> 't.id, t.subject, t.forum_id',
-			'FROM'		=> 'posts AS p',
-			'JOINS'		=> array(
-				array(
-					'INNER JOIN'	=> 'topics AS t',
-					'ON'			=> 't.id=p.topic_id'
-				)
-			),
-			'WHERE'		=> 'p.id='.$post_id
-		);
-
-		($hook = get_hook('mi_report_qr_get_topic_data')) ? eval($hook) : null;
-		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
-		if (!$forum_db->num_rows($result))
-			message($lang_common['Bad request']);
-
-		list($topic_id, $subject, $forum_id) = $forum_db->fetch_row($result);
-
-		($hook = get_hook('mi_report_pre_reports_sent')) ? eval($hook) : null;
-
-		// Should we use the internal report handling?
-		if ($forum_config['o_report_method'] == 0 || $forum_config['o_report_method'] == 2)
+		if (strlen($reason) > FORUM_MAX_POSTSIZE_BYTES)
 		{
+			$errors[] = sprintf($lang_misc['Too long reason'], forum_number_format(strlen($reason)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
+		}
+
+		if (empty($errors)) {
+			// Get some info about the topic we're reporting
 			$query = array(
-				'INSERT'	=> 'post_id, topic_id, forum_id, reported_by, created, message',
-				'INTO'		=> 'reports',
-				'VALUES'	=> $post_id.', '.$topic_id.', '.$forum_id.', '.$forum_user['id'].', '.time().', \''.$forum_db->escape($reason).'\''
+				'SELECT'	=> 't.id, t.subject, t.forum_id',
+				'FROM'		=> 'posts AS p',
+				'JOINS'		=> array(
+					array(
+						'INNER JOIN'	=> 'topics AS t',
+						'ON'			=> 't.id=p.topic_id'
+					)
+				),
+				'WHERE'		=> 'p.id='.$post_id
 			);
 
-			($hook = get_hook('mi_report_add_report')) ? eval($hook) : null;
-			$forum_db->query_build($query) or error(__FILE__, __LINE__);
-		}
+			($hook = get_hook('mi_report_qr_get_topic_data')) ? eval($hook) : null;
+			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
+			if (!$forum_db->num_rows($result))
+				message($lang_common['Bad request']);
 
-		// Should we e-mail the report?
-		if ($forum_config['o_report_method'] == 1 || $forum_config['o_report_method'] == 2)
-		{
-			// We send it to the complete mailing-list in one swoop
-			if ($forum_config['o_mailing_list'] != '')
+			list($topic_id, $subject, $forum_id) = $forum_db->fetch_row($result);
+
+			($hook = get_hook('mi_report_pre_reports_sent')) ? eval($hook) : null;
+
+			// Should we use the internal report handling?
+			if ($forum_config['o_report_method'] == 0 || $forum_config['o_report_method'] == 2)
 			{
-				$mail_subject = 'Report('.$forum_id.') - \''.$subject.'\'';
-				$mail_message = 'User \''.$forum_user['username'].'\' has reported the following message:'."\n".forum_link($forum_url['post'], $post_id)."\n\n".'Reason:'."\n".$reason;
+				$query = array(
+					'INSERT'	=> 'post_id, topic_id, forum_id, reported_by, created, message',
+					'INTO'		=> 'reports',
+					'VALUES'	=> $post_id.', '.$topic_id.', '.$forum_id.', '.$forum_user['id'].', '.time().', \''.$forum_db->escape($reason).'\''
+				);
 
-				if (!defined('FORUM_EMAIL_FUNCTIONS_LOADED'))
-					require FORUM_ROOT.'include/email.php';
+				($hook = get_hook('mi_report_add_report')) ? eval($hook) : null;
+				$forum_db->query_build($query) or error(__FILE__, __LINE__);
+			}
 
-				($hook = get_hook('mi_report_modify_message')) ? eval($hook) : null;
+			// Should we e-mail the report?
+			if ($forum_config['o_report_method'] == 1 || $forum_config['o_report_method'] == 2)
+			{
+				// We send it to the complete mailing-list in one swoop
+				if ($forum_config['o_mailing_list'] != '')
+				{
+					$mail_subject = 'Report('.$forum_id.') - \''.$subject.'\'';
+					$mail_message = 'User \''.$forum_user['username'].'\' has reported the following message:'."\n".forum_link($forum_url['post'], $post_id)."\n\n".'Reason:'."\n".$reason;
+
+					if (!defined('FORUM_EMAIL_FUNCTIONS_LOADED'))
+						require FORUM_ROOT.'include/email.php';
 
-				forum_mail($forum_config['o_mailing_list'], $mail_subject, $mail_message);
+					($hook = get_hook('mi_report_modify_message')) ? eval($hook) : null;
+
+					forum_mail($forum_config['o_mailing_list'], $mail_subject, $mail_message);
+				}
 			}
-		}
 
-		// Set last_email_sent time to prevent flooding
-		$query = array(
-			'UPDATE'	=> 'users',
-			'SET'		=> 'last_email_sent='.time(),
-			'WHERE'		=> 'id='.$forum_user['id']
-		);
+			// Set last_email_sent time to prevent flooding
+			$query = array(
+				'UPDATE'	=> 'users',
+				'SET'		=> 'last_email_sent='.time(),
+				'WHERE'		=> 'id='.$forum_user['id']
+			);
 
-		($hook = get_hook('mi_report_qr_update_last_email_sent')) ? eval($hook) : null;
-		$forum_db->query_build($query) or error(__FILE__, __LINE__);
+			($hook = get_hook('mi_report_qr_update_last_email_sent')) ? eval($hook) : null;
+			$forum_db->query_build($query) or error(__FILE__, __LINE__);
 
-		($hook = get_hook('mi_report_pre_redirect')) ? eval($hook) : null;
+			($hook = get_hook('mi_report_pre_redirect')) ? eval($hook) : null;
 
-		redirect(forum_link($forum_url['post'], $post_id), $lang_misc['Report redirect']);
+			redirect(forum_link($forum_url['post'], $post_id), $lang_misc['Report redirect']);
+		}
 	}
 
 	// Setup form
@@ -480,6 +495,25 @@
 		<div id="req-msg" class="req-warn ct-box error-box">
 			<p class="important"><?php printf($lang_common['Required warn'], '<em>'.$lang_common['Required'].'</em>') ?></p>
 		</div>
+<?php
+		// If there were any errors, show them
+		if (!empty($errors)) {
+			$forum_page['errors'] = array();
+			foreach ($errors as $cur_error) {
+				$forum_page['errors'][] = '<li class="warn"><span>'.$cur_error.'</span></li>';
+			}
+
+			($hook = get_hook('mi_pre_report_errors')) ? eval($hook) : null;
+?>
+		<div class="ct-box error-box">
+			<h2 class="warn hn"><?php echo $lang_misc['Report errors'] ?></h2>
+			<ul class="error-list">
+				<?php echo implode("\n\t\t\t\t", $forum_page['errors'])."\n" ?>
+			</ul>
+		</div>
+<?php
+		}
+?>
 		<form id="afocus" class="frm-form" method="post" accept-charset="utf-8" action="<?php echo $forum_page['form_action'] ?>">
 			<div class="hidden">
 				<?php echo implode("\n\t\t\t\t", $forum_page['hidden_fields'])."\n" ?>
diff -urN punbb-1.3.4/moderate.php punbb-1.3.6/moderate.php
--- punbb-1.3.4/moderate.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/moderate.php	2009-11-11 10:55:40.037101000 +0000
@@ -63,7 +63,7 @@
 
 // Get some info about the forum we're moderating
 $query = array(
-	'SELECT'	=> 'f.forum_name, f.redirect_url, f.num_topics, f.moderators',
+	'SELECT'	=> 'f.forum_name, f.redirect_url, f.num_topics, f.moderators, f.sort_by',
 	'FROM'		=> 'forums AS f',
 	'JOINS'		=> array(
 		array(
@@ -1433,7 +1433,7 @@
 	'SELECT'	=> 't.id, t.poster, t.subject, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to',
 	'FROM'		=> 'topics AS t',
 	'WHERE'		=> 'forum_id='.$fid,
-	'ORDER BY'	=> 't.sticky DESC, last_post DESC',
+	'ORDER BY'	=> 't.sticky DESC, '.(($cur_forum['sort_by'] == '1') ? 't.posted' : 't.last_post').' DESC',
 	'LIMIT'		=>	$forum_page['start_from'].', '.$forum_user['disp_topics']
 );
 
diff -urN punbb-1.3.4/post.php punbb-1.3.6/post.php
--- punbb-1.3.4/post.php	2009-05-15 11:25:04.093166000 +0000
+++ punbb-1.3.6/post.php	2011-03-07 20:13:25.892986000 +0000
@@ -124,7 +124,7 @@
 			$errors[] = $lang_post['No subject'];
 		else if (utf8_strlen($subject) > 70)
 			$errors[] = $lang_post['Too long subject'];
-		else if ($forum_config['p_subject_all_caps'] == '0' && utf8_strtoupper($subject) == $subject && !$forum_page['is_admmod'])
+		else if ($forum_config['p_subject_all_caps'] == '0' && check_is_all_caps($subject) && !$forum_page['is_admmod'])
 			$errors[] = $lang_post['All caps subject'];
 	}
 
@@ -168,7 +168,7 @@
 
 	if (strlen($message) > FORUM_MAX_POSTSIZE_BYTES)
 		$errors[] = sprintf($lang_post['Too long message'], forum_number_format(strlen($message)), forum_number_format(FORUM_MAX_POSTSIZE_BYTES));
-	else if ($forum_config['p_message_all_caps'] == '0' && utf8_strtoupper($message) == $message && !$forum_page['is_admmod'])
+	else if ($forum_config['p_message_all_caps'] == '0' && check_is_all_caps($message) && !$forum_page['is_admmod'])
 		$errors[] = $lang_post['All caps message'];
 
 	// Validate BBCode syntax
diff -urN punbb-1.3.4/profile.php punbb-1.3.6/profile.php
--- punbb-1.3.4/profile.php	2009-05-20 09:08:28.810294000 +0000
+++ punbb-1.3.6/profile.php	2011-09-19 06:35:43.557425000 +0000
@@ -336,7 +336,7 @@
 			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
 				<legend class="group-legend"><strong><?php echo $lang_common['Required information'] ?></strong></legend>
 <?php ($hook = get_hook('pf_change_pass_normal_pre_old_password')) ? eval($hook) : null; ?>
-<?php if (!$forum_user['is_admmod']): ?>
+<?php if (!$forum_user['is_admmod'] || $forum_user['id'] == $id): ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text required">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_profile['Old password'] ?> <em><?php echo $lang_common['Required'] ?></em></span> <small><?php echo $lang_profile['Old password help'] ?></small></label><br />
@@ -847,7 +847,7 @@
 
 	($hook = get_hook('pf_ban_user_selected')) ? eval($hook) : null;
 
-	redirect(forum_link($forum_url['admin_bans']).'?add_ban='.$id, $lang_profile['Ban redirect']);
+	redirect(forum_link($forum_url['admin_bans']).'&amp;add_ban='.$id, $lang_profile['Ban redirect']);
 }
 
 
@@ -957,9 +957,15 @@
 			$form['dst'] = (isset($form['dst'])) ? 1 : 0;
 			$form['time_format'] = (isset($form['time_format'])) ? intval($form['time_format']) : 0;
 			$form['date_format'] = (isset($form['date_format'])) ? intval($form['date_format']) : 0;
+			$form['timezone'] = (isset($form['timezone'])) ? floatval($form['timezone']) : $forum_config['o_default_timezone'];
+
+			// Validate timezone
+			if (($form['timezone'] > 14.0) || ($form['timezone'] < -12.0)) {
+				message($lang_common['Bad request']);
+			}
 
 			$form['email_setting'] = intval($form['email_setting']);
-			if ($form['email_setting'] < 0 && $form['email_setting'] > 2) $form['email_setting'] = 1;
+			if ($form['email_setting'] < 0 || $form['email_setting'] > 2) $form['email_setting'] = 1;
 
 			if ($forum_config['o_subscriptions'] == '1')
 			{
@@ -1012,7 +1018,7 @@
 			if (substr_count($form['signature'], "\n") > ($forum_config['p_sig_lines'] - 1))
 				$errors[] = sprintf($lang_profile['Sig too many lines'], forum_number_format($forum_config['p_sig_lines']));
 
-			if ($form['signature'] != '' && $forum_config['p_sig_all_caps'] == '0' && utf8_strtoupper($form['signature']) == $form['signature'] && !$forum_user['is_admmod'])
+			if ($form['signature'] != '' && $forum_config['p_sig_all_caps'] == '0' && check_is_all_caps($form['signature']) && !$forum_user['is_admmod'])
 				$form['signature'] = utf8_ucwords(utf8_strtolower($form['signature']));
 
 			// Validate BBCode syntax
@@ -1828,14 +1834,14 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_profile['Website'] ?></span></label><br />
-						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[url]" value="<?php echo(isset($form['url']) ? forum_htmlencode($form['url']) : forum_htmlencode($user['url'])) ?>" size="50" maxlength="80" /></span>
+						<span class="fld-input"><input type="text" id="fld<?php echo $forum_page['fld_count'] ?>" name="form[url]" value="<?php echo(isset($form['url']) ? forum_htmlencode($form['url']) : forum_htmlencode($user['url'])) ?>" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('pf_change_details_identity_pre_jabber')) ? eval($hook) : null; ?>
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_profile['Jabber'] ?></span></label><br />
-						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="form[jabber]" value="<?php echo(isset($form['jabber']) ? forum_htmlencode($form['jabber']) : forum_htmlencode($user['jabber'])) ?>" size="40" maxlength="80" /></span>
+						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="form[jabber]" value="<?php echo(isset($form['jabber']) ? forum_htmlencode($form['jabber']) : forum_htmlencode($user['jabber'])) ?>" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('pf_change_details_identity_pre_icq')) ? eval($hook) : null; ?>
@@ -1849,7 +1855,7 @@
 				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
 					<div class="sf-box text">
 						<label for="fld<?php echo ++$forum_page['fld_count'] ?>"><span><?php echo $lang_profile['MSN'] ?></span></label><br />
-						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="form[msn]" value="<?php echo(isset($form['msn']) ? forum_htmlencode($form['msn']) : forum_htmlencode($user['msn'])) ?>" size="40" maxlength="80" /></span>
+						<span class="fld-input"><input id="fld<?php echo $forum_page['fld_count'] ?>" type="text" name="form[msn]" value="<?php echo(isset($form['msn']) ? forum_htmlencode($form['msn']) : forum_htmlencode($user['msn'])) ?>" size="35" maxlength="80" /></span>
 					</div>
 				</div>
 <?php ($hook = get_hook('pf_change_details_identity_pre_aim')) ? eval($hook) : null; ?>
@@ -2256,7 +2262,7 @@
 		$forum_page['crumbs'] = array(
 			array($forum_config['o_board_title'], forum_link($forum_url['index'])),
 			array(sprintf($lang_profile['Users profile'], $user['username']), forum_link($forum_url['user'], $id)),
-			array($lang_profile['Section signature'],forum_link($forum_url['profile_signature'], $id))
+			array($lang_profile['Section signature'], forum_link($forum_url['profile_signature'], $id))
 		);
 
 		// Setup the form
@@ -2308,7 +2314,7 @@
 
 ?>
 		<div class="ct-box error-box">
-			<h2 class="warn hn"><?php echo $lang_profile['Profile update errors'] ?></h3>
+			<h2 class="warn hn"><?php echo $lang_profile['Profile update errors'] ?></h2>
 			<ul class="error-list">
 				<?php echo implode("\n\t\t\t\t\t", $forum_page['errors'])."\n" ?>
 			</ul>
@@ -2513,10 +2519,10 @@
 		$forum_page['user_management'] = array();
 
 		if ($forum_user['g_moderator'] == '1')
-			$forum_page['user_management']['ban'] = '<div class="ct-set set'.++$forum_page['item_count'].'">'."\n\t\t\t\t".'<div class="ct-box">'."\n\t\t\t\t\t".'<h3 class="ct-legend hn">'.$lang_profile['Ban user'].'</h3>'."\n\t\t\t\t".'<p><a href="'.forum_link($forum_url['admin_bans']).'?add_ban='.$id.'">'.$lang_profile['Ban user info'].'</a></p>'."\n\t\t\t\t".'</div>'."\n\t\t\t".'</div>';
+			$forum_page['user_management']['ban'] = '<div class="ct-set set'.++$forum_page['item_count'].'">'."\n\t\t\t\t".'<div class="ct-box">'."\n\t\t\t\t\t".'<h3 class="ct-legend hn">'.$lang_profile['Ban user'].'</h3>'."\n\t\t\t\t".'<p><a href="'.forum_link($forum_url['admin_bans']).'&amp;add_ban='.$id.'">'.$lang_profile['Ban user info'].'</a></p>'."\n\t\t\t\t".'</div>'."\n\t\t\t".'</div>';
 		else if ($forum_user['g_moderator'] != '1' && $user['g_id'] != FORUM_ADMIN )
 		{
-			$forum_page['user_management']['ban'] = '<div class="ct-set set'.++$forum_page['item_count'].'">'."\n\t\t\t\t".'<div class="ct-box">'."\n\t\t\t\t\t".'<h3 class="ct-legend hn">'.$lang_profile['Ban user'].'</h3>'."\n\t\t\t\t".'<p><a href="'.forum_link($forum_url['admin_bans']).'?add_ban='.$id.'">'.$lang_profile['Ban user info'].'</a></p>'."\n\t\t\t\t".'</div>'."\n\t\t\t".'</div>';
+			$forum_page['user_management']['ban'] = '<div class="ct-set set'.++$forum_page['item_count'].'">'."\n\t\t\t\t".'<div class="ct-box">'."\n\t\t\t\t\t".'<h3 class="ct-legend hn">'.$lang_profile['Ban user'].'</h3>'."\n\t\t\t\t".'<p><a href="'.forum_link($forum_url['admin_bans']).'&amp;add_ban='.$id.'">'.$lang_profile['Ban user info'].'</a></p>'."\n\t\t\t\t".'</div>'."\n\t\t\t".'</div>';
 			$forum_page['user_management']['delete'] = '<div class="ct-set set'.++$forum_page['item_count'].'">'."\n\t\t\t\t".'<div class="ct-box">'."\n\t\t\t\t\t".'<h3 class="ct-legend hn">'.$lang_profile['Delete user'].'</h3>'."\n\t\t\t\t".'<p><a href="'.forum_link($forum_url['delete_user'], $id).'">'.$lang_profile['Delete user info'].'</a></p>'."\n\t\t\t\t".'</div>'."\n\t\t\t".'</div>';
 		}
 
diff -urN punbb-1.3.4/register.php punbb-1.3.6/register.php
--- punbb-1.3.4/register.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/register.php	2011-03-10 07:44:00.623008000 +0000
@@ -163,6 +163,14 @@
 		if ($banned_email && $forum_config['p_allow_banned_email'] == '0')
 			$errors[] = $lang_profile['Banned e-mail'];
 
+		// Clean old unverified registrators - delete older than 72 hours
+		$query = array(
+			'DELETE'	=> 'users',
+			'WHERE'		=> 'group_id='.FORUM_UNVERIFIED.' AND activate_key IS NOT NULL AND registered < '.(time() - 259200)
+		);
+		($hook = get_hook('rg_register_qr_delete_unverified')) ? eval($hook) : null;
+		$forum_db->query_build($query) or error(__FILE__, __LINE__);
+
 		// Check if someone else already has registered with that e-mail address
 		$dupe_list = array();
 
diff -urN punbb-1.3.4/search.php punbb-1.3.6/search.php
--- punbb-1.3.4/search.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/search.php	2009-11-05 08:46:18.150283000 +0000
@@ -533,25 +533,29 @@
 ($hook = get_hook('se_qr_get_cats_and_forums')) ? eval($hook) : null;
 $result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
 
-$cur_category = 0;
-while ($cur_forum = $forum_db->fetch_assoc($result))
+if ($forum_db->num_rows($result) > 0)
 {
-	($hook = get_hook('se_forum_loop_start')) ? eval($hook) : null;
-
-	if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
+	$cur_category = 0;
+	while ($cur_forum = $forum_db->fetch_assoc($result))
 	{
-		if ($cur_category)
-			echo "\t\t\t\t\t\t\t".'</fieldset>'."\n";
+		($hook = get_hook('se_forum_loop_start')) ? eval($hook) : null;
+
+		if ($cur_forum['cid'] != $cur_category)	// A new category since last iteration?
+		{
+			if ($cur_category)
+				echo "\t\t\t\t\t\t\t".'</fieldset>'."\n";
+
+			echo "\t\t\t\t\t\t\t".'<fieldset>'."\n\t\t\t\t\t\t\t\t".'<legend><span>'.forum_htmlencode($cur_forum['cat_name']).':</span></legend>'."\n";
+			$cur_category = $cur_forum['cid'];
+		}
 
-		echo "\t\t\t\t\t\t\t".'<fieldset>'."\n\t\t\t\t\t\t\t\t".'<legend><span>'.forum_htmlencode($cur_forum['cat_name']).':</span></legend>'."\n";
-		$cur_category = $cur_forum['cid'];
+		echo "\t\t\t\t\t\t\t\t".'<div class="checklist-item"><span class="fld-input"><input type="checkbox" id="fld'.(++$forum_page['fld_count']).'"  name="forum[]" value="'.$cur_forum['fid'].'" /></span> <label for="fld'.$forum_page['fld_count'].'">'.forum_htmlencode($cur_forum['forum_name']).'</label></div>'."\n";
 	}
 
-	echo "\t\t\t\t\t\t\t\t".'<div class="checklist-item"><span class="fld-input"><input type="checkbox" id="fld'.(++$forum_page['fld_count']).'"  name="forum[]" value="'.$cur_forum['fid'].'" /></span> <label for="fld'.$forum_page['fld_count'].'">'.forum_htmlencode($cur_forum['forum_name']).'</label></div>'."\n";
+	echo "\t\t\t\t\t\t\t".'</fieldset>'."\n";
 }
 
 ?>
-							</fieldset>
 						</div>
 					</div>
 <?php ($hook = get_hook('se_pre_forum_fieldset_end')) ? eval($hook) : null; ?>
diff -urN punbb-1.3.4/style/Oxygen/Oxygen.php punbb-1.3.6/style/Oxygen/Oxygen.php
--- punbb-1.3.4/style/Oxygen/Oxygen.php	2008-10-25 15:27:40.628806000 +0000
+++ punbb-1.3.6/style/Oxygen/Oxygen.php	2011-03-16 08:31:13.228777000 +0000
@@ -1,4 +1,5 @@
 <link rel="stylesheet" type="text/css" media="screen" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen.css" />
 <link rel="stylesheet" type="text/css" media="screen" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen_cs.css" />
 <!--[if lte IE 6]><link rel="stylesheet" type="text/css" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen_ie6.css" /><![endif]-->
-<!--[if IE 7]><link rel="stylesheet" type="text/css" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen_ie7.css" /><![endif]-->
\ No newline at end of file
+<!--[if IE 7]><link rel="stylesheet" type="text/css" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen_ie7.css" /><![endif]-->
+<!--[if IE 8]><link rel="stylesheet" type="text/css" href="<?php echo $base_url.'/style/'.$forum_user['style'] ?>/Oxygen_ie8.css" /><![endif]-->
\ No newline at end of file
diff -urN punbb-1.3.4/viewtopic.php punbb-1.3.6/viewtopic.php
--- punbb-1.3.4/viewtopic.php	2009-04-17 12:51:23.967251000 +0000
+++ punbb-1.3.6/viewtopic.php	2011-03-15 16:47:47.444999000 +0000
@@ -259,7 +259,7 @@
 <?php
 
 	if (!empty($forum_page['main_head_options']))
-		echo "\n\t\t".'<p class="options">'.implode(' ', $forum_page['main_head_options']).'</p>';
+		echo "\t\t".'<p class="options">'.implode(' ', $forum_page['main_head_options']).'</p>'."\n";
 
 ?>
 		<h2 class="hn"><span><?php echo $forum_page['items_info'] ?></span></h2>
@@ -408,7 +408,7 @@
 			}
 			else
 			{
-				if ($cur_post['poster_email'] != '' && !$forum_user['is_guest'] && $forum_user['g_send_email'] == '1')
+				if ($cur_post['poster_email'] != '' && $forum_user['is_admmod'] && $forum_user['g_send_email'] == '1')
 					$forum_page['post_contacts']['email'] = '<span class="user-email'.(empty($forum_page['post_contacts']) ? ' first-item' : '').'"><a href="mailto:'.forum_htmlencode($cur_post['poster_email']).'">'.$lang_topic['E-mail'].'<span>&#160;'.forum_htmlencode($cur_post['username']).'</span></a></span>';
 			}
 		}
